
/*
*******************************************************************************
Define Part
*******************************************************************************
*/
#define READ_SWITCH			0x01
#define READ_DIP				0x02
//
#define WRITE_LED_1_ON			0x01
#define WRITE_LED_1_OFF		0x02
#define WRITE_LED_2_ON			0x03
#define WRITE_LED_2_OFF		0x04

//FB755AX
#define WRITE_S_CONTROL_HIGH	0x05
#define WRITE_S_CONTROL_LOW	0x06
//#define CONNECT_DEV_NUM		0x31
//#define CONNECT_DEV_NUM		0x32
//#define CONNECT_DEV_NUM		0x33
#define CONNECT_DEV_NUM		0x34
//#define CONNECT_DEV_NUM		0x35
//#define CONNECT_DEV_NUM		0x36
//#define CONNECT_DEV_NUM		0x37

//distribute data
#define DATA_OK			0x01
#define DATA_ERROR		0x02
#define STATUS_CON		0x03
#define STATUS_DISCON	0x04
//

#define SWITCH_1		0x0e
#define SWITCH_2		0x0d
#define SWITCH_3		0x0b
#define SWITCH_4		0x07

#define S_STATUS_LOW	0x00
#define S_STATUS_HIGH	0x02
#define READ_S_STATUS	0x03

#define ERROR			0x00
#define OK				0x01
//
#define DIP_1		0x10
#define DIP_2		0x20
#define DIP_3		0x40
#define DIP_4		0x80
#define DIP_1_2		0x30
#define DIP_1_3		0x50
#define DIP_1_4		0x90
//
#define DIP_2_2		0x20
#define DIP_2_3		0x60
#define DIP_2_4		0xa0
#define DIP_2_3_4	0xe0
#define DIP_ALL_HIGH	0xf0

//
#define UART1_BUF_SIZE 128
#define UART0_BUF_SIZE 512
//
#define BAUD_9600		0x05
#define BAUD_19200		0x06
#define BAUD_38400		0x07
#define BAUD_57600		0x08
#define BAUD_115200		0x09
//
#define LF_VALUE		0x0a
//
#define LF_CHECK_NON	0x00
#define LF_CHECK_OK		0x01
//
#define STEP_0	0
#define STEP_1	1
#define STEP_2	2
#define STEP_3	3
#define STEP_4	4
#define STEP_5	5
#define STEP_6	6
#define STEP_7	7
#define STEP_8	8
#define STEP_9	9
#define STEP_10	10
#define STEP_11	11
#define STEP_12	12
#define STEP_13	13
#define STEP_14	14
#define STEP_15	15
#define STEP_16	16
#define STEP_17	17
#define STEP_18	18
#define STEP_19	19
#define STEP_20	20
//
#define BEFORE_CONNECT	0x00
#define AFTER_CONNECT	0x01
//
#define TARGET_NOT_DETECT	0x00
#define TARGET_DETECT		0x01
//
#define sbi(x,y)x|=_BV(y)
#define cbi(x,y)x&=~(_BV(y))
//
/*
*******************************************************************************
Function Prototype Declaration Part
*******************************************************************************
*/
void wait_1ms(unsigned int cnt);
void wait_1us(unsigned int cnt);
//
void init_port(void);
//
unsigned char read_port_value(unsigned char avr_port_num);
void write_port_value(unsigned char avr_port_value);
//
void Init_UART0(unsigned char baudrate);
unsigned int Check_Rx_Buf0(void);
unsigned char GetChar0 (void);
unsigned char PutChar0 (unsigned char c);
void DispStr0 (char *s);
void DispStr0_line (char *s);
//
void Init_UART1(unsigned char baudrate);
unsigned int Check_Rx_Buf1(void);
unsigned char GetChar1 (void);
unsigned char PutChar1 (unsigned char c);
void DispStr1 (char *s);
void DispStr1_line (char *s);

//
unsigned char Hex2Char(unsigned char c);
//
void compare_slave_command(void);
void execution_slave(void);
//
void compare_master_command(void);
void execution_master(void);
//
void execution_error(void);
//
void init_uart0_read_data(void);
//
void init_timer0(void);
void status_led(void);
//
void get_bluetooth_address(void);

//FB755AX
void execution_stream_control(void);
void execution_check_s_status_low(void);
void execution_check_s_status_high(void);

//distribute data
void execution_distribute_received_message(void);
void execution_get_received_message(void);
void execution_put_received_message(void);

//transfer data
void execution_transfer_data(void);

/*
********************************************************************************
Local Variable Declaration Section
********************************************************************************
*/
unsigned char read_avr_port;
//
unsigned char rx0_buf[UART0_BUF_SIZE];
unsigned char rx1_buf[UART1_BUF_SIZE];
unsigned int p_rx1_wr, p_rx1_rd;
unsigned int p_rx0_wr, p_rx0_rd;
//
unsigned int timer0_counter;
//
unsigned char lf_check_flag;

unsigned int uart0_length,uart1_length;
unsigned char uart0_read_data[50];

unsigned char step_slave_bt;
unsigned char step_master_bt;
unsigned char status_sequence;
unsigned char status_target;

unsigned char target_data[50];

//FB755AX
unsigned char connect_count;
unsigned char old_switch_value;
unsigned char stream_status;
unsigned char s_status_value;
unsigned int loop_count_1,loop_count_2;

//distribute data
unsigned char message_value;

//transfer data
unsigned int transfer_interval;
unsigned int transfer_value;
//


